local MAX_PRICE = 999999;
local min_minBid = MAX_PRICE;
local min_buyOut = MAX_PRICE;
local user_itemcount = 1;

-- Startup Function
function LeastPriceAuction_OnLoad()
	this:RegisterEvent("NEW_AUCTION_UPDATE");
	this:RegisterEvent("AUCTION_HOUSE_CLOSED");
	this:RegisterEvent("AUCTION_ITEM_LIST_UPDATE");
	DEFAULT_CHAT_FRAME:AddMessage("Least-Price Auction Agent v1.0 Loaded!");
end

function LeastPriceAuction_OnEvent()
	if (event == "NEW_AUCTION_UPDATE") then
		local sell_name, sell_texture, sell_count, sell_quality, sell_canUse, sell_price = GetAuctionSellItemInfo();
		user_itemcount = sell_count;
		
		-- sell_name ȿ , , item ()  .
		if ( sell_name~=nil ) then
			DEFAULT_CHAT_FRAME:AddMessage( sell_name );
			QueryAuctionItems( sell_name, "", "", nil, nil, nil, nil, sell_canUse, sell_quality)			
		end
	
	elseif (event == "AUCTION_ITEM_LIST_UPDATE") then
		min_minBid = MAX_PRICE;
		min_buyOut = MAX_PRICE;
	
		local batch,count = GetNumAuctionItems("list");
		--DEFAULT_CHAT_FRAME:AddMessage( count );
		
		if ( count == 0 ) then
			DEFAULT_CHAT_FRAME:AddMessage("There's no item fetched");
		end

		for i = 1, count do
			name, texture, ncount, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner  
				= GetAuctionItemInfo("list", i);
			each_minBid = minBid / ncount;
			each_buyoutPrice = buyoutPrice / ncount;
			if ( (each_minBid>0) and ( min_minBid > each_minBid ) ) then
				min_minBid = each_minBid;
			end
			if ((each_buyoutPrice>0) and ( min_buyOut > each_buyoutPrice )) then
				min_buyOut = each_buyoutPrice;
				--DEFAULT_CHAT_FRAME:AddMessage( each_buyoutPrice );
			end
		end
	
		if ( min_minBid and min_buyOut ) then
			if ( min_buyOut < min_minBid ) then
			-- ۰ ﱸ ū  ó
				min_minBid = min_buyOut;
			end
			
			if ( min_buyOut ~= MAX_PRICE ) then
				MoneyInputFrame_SetCopper(BuyoutPrice, min_buyOut * user_itemcount);
			end
			if ( min_minBid ~= MAX_PRICE ) then
				MoneyInputFrame_SetCopper(StartPrice, min_minBid * user_itemcount);
			end
			
		else
			DEFAULT_CHAT_FRAME:AddMessage("There's no item fetched");
		end
	
	elseif (event == "AUCTION_HOUSE_CLOSED") then
		DEFAULT_CHAT_FRAME:AddMessage("Bye");
	end	
end
